import pickle

import matplotlib.pyplot as plt
import numpy as np
from arthur import main_log

preds = pickle.load(open('ego_2048x512.pkl', 'rb'))
datas = pickle.load(open('data_nocam.pkl', 'rb'))[::3]

vis_xy = []

reference_transform = None

preds_length = len(preds)


for timestamp, (curr_pred, data) in enumerate(zip(preds, datas)):
    if reference_transform is None:
        reference_transform = data["ego"]["world_to_ego_transform"]

    results = []
    curr_pred = np.squeeze(curr_pred, 0)
    curr_pred = np.concatenate([
        np.zeros((1, 3)),
        curr_pred
    ], axis=0)

    # 1 + 40
    L = curr_pred.shape[0]
    heading = curr_pred[:, -1]

    w2e = data['ego']['world_to_ego_transform']
    e2w = np.linalg.inv(data['ego']['world_to_ego_transform'])

    local_xyz_offset = np.concatenate([
        # x, y
        curr_pred[:, :2],
        # z=0
        np.zeros((L, 1))
    ], axis=1)

    # list of [1, 3], 3 is [x,y,z]
    global_xyz_offset = [
        (e2w @ np.append(local_xyz_offset[i], 1.0))[None, :3] for i in range(L)
    ]

    # [41, 3]
    global_xyz_offset = np.concatenate(global_xyz_offset, 0)
    final_offset = global_xyz_offset

    # vis pred
    actual_len = final_offset.shape[0]
    homogenous_xyz = np.concatenate([
        final_offset, np.ones((actual_len, 1))
    ], 1)

    trajectory_point = np.concatenate(
        [(reference_transform @ homogenous_xyz[i])[:2][None] for i in range(actual_len // 4)],
        0
    )
    vis_xy.append(trajectory_point)
vis_xy = np.concatenate(vis_xy, 0)
plt.clf()
plt.cla()
main_log()
plt.scatter(vis_xy[:, 0], vis_xy[:, 1], s=2)
plt.xlim((-2, 130))
plt.ylim((-1, 15))
plt.title(f"ego trajectory")
plt.savefig(f"my_trajs/ALL_TRAJS.png")
