import pickle

import torch
import os
"""
subscores -> total score
"""
root = f'{os.getenv("NAVSIM_EXP_ROOT")}/hydra_pe_video_mult0.5_2048_512_temporal_bs8x8_ckpt'
subscores_name = 'epoch18'

subscores = pickle.load(open(f'{root}/{subscores_name}.pkl', 'rb'))

for token, subscore in subscores.items():
    for k, v in subscore.items():
        # print(k)/
        if k == 'trajectory_pre' or k == 'comfort':
            continue
        if k != 'trajectory':
            subscore[k] = torch.from_numpy(v)
    subscores[token]['total'] = (
            0.01 * subscore['imi'] +
            0.01 * subscore['noc'] +
            0.01 * subscore['da'] +
            0.0625 * subscore['dr'] +
            9.0 * subscore['tl'] +
            3.5 * ((
                    7.0 * torch.exp(subscore['ttc']) +
                    # 2 * torch.exp(subscore['comfort']) +
                    3.0 * torch.exp(subscore['progress']) +
                    3.5 * torch.exp(subscore['lk'])

            ) / 13.5).log()
    )

for token, subscore in subscores.items():
    for k, v in subscore.items():
        if k != 'trajectory' and k != 'trajectory_pre' and k != 'comfort':
            subscore[k] = v.numpy()

pickle.dump(subscores, open(f'{root}/{subscores_name}-total2.pkl', 'wb'))
